<?php
//Use Google JS Library
if( !is_admin()){
   wp_deregister_script('jquery'); 
   wp_register_script('jquery', ("https://ajax.googleapis.com/ajax/libs/jquery/1.5.0/jquery.min.js"), false, '1.5.0'); 
   wp_enqueue_script('jquery');
}

//Add Feeds
add_theme_support('automatic-feed-links');

//Remove WordPress Version For Security Reasons
remove_action('wp_head', 'wp_generator');

//Add Pagination Support
include('functions/pagination.php');

// Limit Post Word Count
function new_excerpt_length($length) {
	return 50;
}
add_filter('excerpt_length', 'new_excerpt_length');

//Replace Excerpt Link
function new_excerpt_more($more) {
       global $post;
	return '...';
}
add_filter('excerpt_more', 'new_excerpt_more');

//Activate post-image functionality (WP 2.9+)
if ( function_exists( 'add_theme_support' ) )
add_theme_support( 'post-thumbnails' );

// Enable Custom Background
add_custom_background();

// Register Navigation Menus
register_nav_menus(
	array(
	'primary'=>__('Primary Menu'),
	)
);

//Register Sidebars
if ( function_exists('register_sidebar') )
register_sidebar(array(
'name' => 'Sidebar',
'description' => 'Widgets in this area will be shown in the sidebar.',
'before_widget' => '<div class="xs-sidebar-right-box">',
'after_widget' => '</div>',
'before_title' => '<h4>',
'after_title' => '</h4>',
));

// Get Post Categories
$categories = get_categories('hide_empty=0&orderby=name');
$wp_cats = array();
foreach ($categories as $category_list ) {
       $wp_cats[$category_list->cat_ID] = $category_list->cat_name;
}
array_unshift($wp_cats, "Choose a category");

// Start Admin Panel
$themename = "Theme Panel";
$shortname = "xs";

// Theme Options
$options = array (
array( "name" => $themename." Options",
	"type" => "title"),
array( "name" => "Favicon",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Custom Favicon",
	"desc" => "A favicon is a 16x16 pixel icon that represents your site; paste the URL to a .ico image that you want to use as the image",
	"id" => $shortname."_favicon",
	"type" => "text",
	"std" => get_bloginfo('url') ."/favicon.ico"),
	
array( "type" => "close"),
array( "name" => "TimThumb Image Resizing - Enable for better thumbnail quality",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Enable The TimThumb Script",
	"desc" => "This script will automatically resize images for faster speed and better quality images. Not all servers can support it.",
	"id" => $shortname."_enable_timthumb",
	"type" => "checkbox",
	"std" => "false"),

array( "type" => "close"),
array( "name" => "Image Slider",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Slider Category",
	"desc" => "Choose a category for your featured slider",
	"id" => $shortname."_feat_cat",
	"type" => "select",
	"options" => $wp_cats,
	"std" => "Choose a category"),
	
array( "name" => "How Many Slides",
	"desc" => "How many slides do you want to show on the slider?",
	"id" => $shortname."_feat_cat_slides",
	"type" => "text",
	"std" => "3"),

array( "name" => "Pause Time",
	"desc" => "Choose the amount of time in milliseconds between each slide",
	"id" => $shortname."_slider_pause",
	"type" => "text",
	"std" => "2000"),

array( "name" => "Slider Speed",
	"desc" => "Choose the transition speed in milliseconds for your slider",
	"id" => $shortname."_slider_speed",
	"type" => "text",
	"std" => "500"),
	
array( "name" => "Animation",
	"desc" => "Choose an animation for your slider",
	"id" => $shortname."_slider_animation",
	"type" => "select",
	"options" => array("random", "slideInLeft", "fade", "fold", "slideInRight",  "sliceDown", "sliceDownLeft", "sliceUp", "sliceUpLeft", "sliceUpDown","sliceUpDownLeft", "slideInRight"),
	"std" => "random"),
	
array( "name" => "Slider Slices",
	"desc" => "Choose number of slices for the slider animation",
	"id" => $shortname."_slider_slices",
	"type" => "text",
	"std" => "15"),
	
array( "type" => "close"),
array( "name" => "Featured Image Options",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Disable Featured Image On Single Posts",
	"desc" => "Check the box to disable the featured images on your single posts",
	"id" => $shortname."_disable_single_thumbnail",
	"type" => "checkbox",
	"std" => "false"),
	
array( "type" => "close"),
array( "name" => "Advertisements",
	"type" => "section"),
array( "type" => "open"),
	
array( "name" => "Top Advertisement Code (468x60 - recommended but not required)",
	"desc" => "Paste your code for the top advertisement spot",
	"id" => $shortname."_header_ad",
	"type" => "textarea",
	"std" => ""),
array( "name" => "Above Post Advertisement Code",
	"desc" => "Paste your code for the post top advertisement spot",
	"id" => $shortname."_top_post_ad",
	"type" => "textarea",
	"std" => ""),
	
array( "name" => "Below Post Advertisement Code",
	"desc" => "Paste your code for the post bottom advertisement spot",
	"id" => $shortname."_bottom_post_ad",
	"type" => "textarea",
	"std" => ""),

array( "type" => "close"),
array( "name" => "Analytics",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Google Analytics Code",
	"desc" => "You can paste your Google Analytics or other tracking code in this box. This will be automatically added to the footer.",
	"id" => $shortname."_ga_code",
	"type" => "textarea",
	"std" => ""),
	
array( "type" => "close")
);


// Define Admin Panel
function mytheme_add_admin() {
global $themename, $shortname, $options;
if ( $_GET['page'] == basename(__FILE__) ) {
	if ( 'save' == $_REQUEST['action'] ) {
		foreach ($options as $value) {
		update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }
foreach ($options as $value) {
	if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }
	header("Location: admin.php?page=functions.php&saved=true");
die;
}
else if( 'reset' == $_REQUEST['action'] ) {
	foreach ($options as $value) {
		delete_option( $value['id'] ); }
	header("Location: admin.php?page=functions.php&reset=true");
die;
}
}
add_menu_page($themename, $themename, 'administrator', basename(__FILE__), 'mytheme_admin');
}


//Get Javascriot and CSS files
function mytheme_add_init() {
$file_dir=get_bloginfo('template_directory');
wp_enqueue_style("functions", $file_dir."/functions/xspanel.css", false, "1.0", "all");
wp_enqueue_script("rm_script", $file_dir."/js/rm_script.js", false, "1.0");

}
function mytheme_admin() {

global $themename, $shortname, $options;
$i=0;
if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';
?>

<div class="wrap rm_wrap">
<h2>Theme Panel</h2>
<p><a href="http://www.wpexplorer.com/" title="Wordpress Themes">Wordpress Themes</a> | <a href="http://www.wpexplorer.com/blog" title="Blog">Blog</a> | <a href="http://www.twitter.com/wpexplorer" title="Follow Me">Follow Me On Twitter</a> (ask me questions @wpexplorer)</p>
<p>
<iframe src="http://www.facebook.com/plugins/like.php?href=http%3A%2F%2Fwww.wpexplorer.com%2Fanton-free-wordpress-theme.html&amp;layout=button_count&amp;show_faces=false&amp;width=450&amp;action=like&amp;font&amp;colorscheme=light&amp;height=21" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:450px; height:21px;" allowTransparency="true"></iframe>
</p>
<div class="rm_opts">
</p>
<form method="post">
  <?php foreach ($options as $value) { switch ( $value['type'] ) { case "open": ?>
  <?php break; case "close": ?>
  
  </div>
  </div>
  <br />

<?php break; case "title": ?>
<?php break; case 'text': ?>

<div class="rm_input rm_text">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
 	<input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo stripslashes(get_settings( $value['id'])  ); } else { echo $value['std']; } ?>" />
	<small><?php echo $value['desc']; ?></small>
	<div class="clearfix"></div>
</div><!-- /rm_input rm_text -->
 
<?php break; case 'textarea': ?>

<div class="rm_input rm_textarea">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
	<textarea name="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" cols="" rows=""><?php if ( get_settings( $value['id'] ) != "") { echo stripslashes(get_settings( $value['id']) ); } else { echo $value['std']; } ?></textarea>
	<small><?php echo $value['desc']; ?></small>
	<div class="clearfix"></div>
</div><!-- /rm_input rm_textarea -->

<?php break; case 'select': ?>

<div class="rm_input rm_select">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
	<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
	<?php foreach ($value['options'] as $option) { ?>
	<option <?php if (get_settings( $value['id'] ) == $option) { echo 'selected="selected"'; } ?>><?php echo $option; ?></option><?php } ?>
	</select>
	<small><?php echo $value['desc']; ?></small>
	<div class="clearfix"></div>
</div><!-- /rm_input rm_select -->

<?php break; case "checkbox": ?>

<div class="rm_input rm_checkbox">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
	<?php if(get_option($value['id'])){ $checked = "checked=\"checked\""; }else{ $checked = "";} ?>
	<input type="checkbox" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" value="true" <?php echo $checked; ?> />
	<small><?php echo $value['desc']; ?></small>
    <div class="clearfix"></div>
</div><!-- /rm_input rm_checkbox -->

<?php break; case "section": $i++ ?>

<div class="rm_section">
<div class="rm_title">
	<h3><img src="" class="inactive" alt="""><?php echo $value['name']; ?></h3>
	<span class="submit"><input name="save<?php echo $i; ?>" type="submit" value="Save changes" /></span><div class="clearfix"></div>
</div>

<div class="rm_options">
<?php break;
}
}
?>
<h3 style="color: #F00;">Reset Theme Panel</h3>
<p>Use with causion - this button will reset your theme panel options to the default settings</p>
<input type="hidden" name="action" value="save" />
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>
<?php } ?>
<?php
add_action('admin_init', 'mytheme_add_init');
add_action('admin_menu', 'mytheme_add_admin');
?>